diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/ms.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/ms.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/ms.php	2013-07-29 13:18:58.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/ms.php	2013-10-23 09:40:10.000000000 -0500
***************
*** 61,67 ****
  	}
  
  	$blog = get_blog_details( $blog_id );
! 
  	do_action( 'delete_blog', $blog_id, $drop );
  
  	$users = get_users( array( 'blog_id' => $blog_id, 'fields' => 'ids' ) );
--- 61,74 ----
  	}
  
  	$blog = get_blog_details( $blog_id );
! 	/**
! 	 * Fires before a blog is deleted.
! 	 *
! 	 * @since MU
! 	 *
! 	 * @param int  $blog_id The blog ID.
! 	 * @param bool $drop    True if blog's table should be dropped. Default is false.
! 	 */
  	do_action( 'delete_blog', $blog_id, $drop );
  
  	$users = get_users( array( 'blog_id' => $blog_id, 'fields' => 'ids' ) );
***************
*** 80,86 ****
  		$drop = false;
  
  	if ( $drop ) {
! 		$drop_tables = apply_filters( 'wpmu_drop_tables', $wpdb->tables( 'blog' ), $blog_id );
  
  		foreach ( (array) $drop_tables as $table ) {
  			$wpdb->query( "DROP TABLE IF EXISTS `$table`" );
--- 87,102 ----
  		$drop = false;
  
  	if ( $drop ) {
! 		$tables = $wpdb->tables( 'blog' );
! 		/**
! 		 * Filter the tables to drop when the blog is deleted.
! 		 *
! 		 * @since MU
! 		 *
! 		 * @param array $tables  The blog tables to be dropped.
! 		 * @param int   $blog_id The ID of the blog to drop tables for.
! 		 */
! 		$drop_tables = apply_filters( 'wpmu_drop_tables', $tables, $blog_id );
  
  		foreach ( (array) $drop_tables as $table ) {
  			$wpdb->query( "DROP TABLE IF EXISTS `$table`" );
***************
*** 89,94 ****
--- 105,118 ----
  		$wpdb->delete( $wpdb->blogs, array( 'blog_id' => $blog_id ) );
  
  		$uploads = wp_upload_dir();
+ 		/**
+ 		 * Filter the upload base directory to delete when the blog is deleted.
+ 		 *
+ 		 * @since MU
+ 		 *
+ 		 * @param string $uploads['basedir'] Uploads path without subdirectory. @see wp_upload_dir()
+ 		 * @param int    $blog_id            The blog ID.
+ 		 */
  		$dir = apply_filters( 'wpmu_delete_blog_upload_dir', $uploads['basedir'], $blog_id );
  		$dir = rtrim( $dir, DIRECTORY_SEPARATOR );
  		$top_dir = $dir;
***************
*** 137,143 ****
  
  	if ( !$user->exists() )
  		return false;
! 
  	do_action( 'wpmu_delete_user', $id );
  
  	$blogs = get_blogs_of_user( $id );
--- 161,173 ----
  
  	if ( !$user->exists() )
  		return false;
! 	/**
! 	 * Fires before a user is deleted from the network.
! 	 *
! 	 * @since MU
! 	 *
! 	 * @param int $id ID of the user about to be deleted from the network.
! 	 */
  	do_action( 'wpmu_delete_user', $id );
  
  	$blogs = get_blogs_of_user( $id );
***************
*** 172,178 ****
  
  	clean_user_cache( $user );
  
! 	// allow for commit transaction
  	do_action( 'deleted_user', $id );
  
  	return true;
--- 202,214 ----
  
  	clean_user_cache( $user );
  
! 	/**
! 	 * Fires after the user is deleted from the network.
! 	 *
! 	 * @since 2.8.0
! 	 *
! 	 * @param int $id ID of the user that was deleted from the network.
! 	 */
  	do_action( 'deleted_user', $id );
  
  	return true;
***************
*** 190,196 ****
  	);
  	update_option( 'adminhash', $new_admin_email );
  
! 	$content = apply_filters( 'new_admin_email_content', __( "Dear user,
  
  You recently requested to have the administration email address on
  your site changed.
--- 226,232 ----
  	);
  	update_option( 'adminhash', $new_admin_email );
  
! 	$email_text = __( 'Dear user,
  
  You recently requested to have the administration email address on
  your site changed.
***************
*** 204,210 ****
  
  Regards,
  All at ###SITENAME###
! ###SITEURL### "), $new_admin_email );
  
  	$content = str_replace( '###ADMIN_URL###', esc_url( admin_url( 'options.php?adminhash='.$hash ) ), $content );
  	$content = str_replace( '###EMAIL###', $value, $content );
--- 240,262 ----
  
  Regards,
  All at ###SITENAME###
! ###SITEURL###' );
! 
! 	/**
! 	 * Filter the email text sent when the site admin email is changed.
! 	 *
! 	 * The following strings have a special meaning and will get replaced dynamically:
! 	 * ###ADMIN_URL### The link to click on to confirm the email change. Required otherwise this functunalty is will break.
! 	 * ###EMAIL###     The new email.
! 	 * ###SITENAME###  The name of the site.
! 	 * ###SITEURL###   The URL to the site.
! 	 *
! 	 * @since MU
! 	 *
! 	 * @param string $email_text      Text in the email.
! 	 * @param string $new_admin_email New admin email that the current administration email was changed to.
! 	 */
! 	$content = apply_filters( 'new_admin_email_content', $email_text, $new_admin_email );
  
  	$content = str_replace( '###ADMIN_URL###', esc_url( admin_url( 'options.php?adminhash='.$hash ) ), $content );
  	$content = str_replace( '###EMAIL###', $value, $content );
***************
*** 244,250 ****
  				);
  		update_option( $current_user->ID . '_new_email', $new_user_email );
  
! 		$content = apply_filters( 'new_user_email_content', __( "Dear user,
  
  You recently requested to have the email address on your account changed.
  If this is correct, please click on the following link to change it:
--- 296,302 ----
  				);
  		update_option( $current_user->ID . '_new_email', $new_user_email );
  
! 		$email_text = __( 'Dear user,
  
  You recently requested to have the email address on your account changed.
  If this is correct, please click on the following link to change it:
***************
*** 257,263 ****
  
  Regards,
  All at ###SITENAME###
! ###SITEURL###" ), $new_user_email );
  
  		$content = str_replace( '###ADMIN_URL###', esc_url( admin_url( 'profile.php?newuseremail='.$hash ) ), $content );
  		$content = str_replace( '###EMAIL###', $_POST['email'], $content);
--- 309,331 ----
  
  Regards,
  All at ###SITENAME###
! ###SITEURL###' );
! 
! 		/**
! 		 * Filter the email text sent when a user changes emails.
! 		 *
! 		 * The following strings have a special meaning and will get replaced dynamically:
! 		 * ###ADMIN_URL### The link to click on to confirm the email change. Required otherwise this functunalty is will break.
! 		 * ###EMAIL### The new email.
! 		 * ###SITENAME### The name of the site.
! 		 * ###SITEURL### The URL to the site.
! 		 *
! 		 * @since MU
! 		 *
! 		 * @param string $email_text     Text in the email.
! 		 * @param string $new_user_email New user email that the current user has changed to.
! 		 */
! 		$content = apply_filters( 'new_user_email_content', $email_text, $new_user_email );
  
  		$content = str_replace( '###ADMIN_URL###', esc_url( admin_url( 'profile.php?newuseremail='.$hash ) ), $content );
  		$content = str_replace( '###EMAIL###', $_POST['email'], $content);
***************
*** 377,386 ****
  	clean_user_cache( $user );
  
  	if ( $pref == 'spam' ) {
! 		if ( $value == 1 )
  			do_action( 'make_spam_user', $id );
! 		else
  			do_action( 'make_ham_user', $id );
  	}
  
  	return $value;
--- 445,469 ----
  	clean_user_cache( $user );
  
  	if ( $pref == 'spam' ) {
! 		if ( $value == 1 ) {
! 			/**
! 			 * Fires after the user is marked as a SPAM user.
! 			 *
! 			 * @since 3.0.0
! 			 *
! 			 * @param int $id ID of the user marked as SPAM.
! 			 */
  			do_action( 'make_spam_user', $id );
! 		} else {
! 			/**
! 			 * Fires after the user is marked as a HAM user. Opposite of SPAM.
! 			 *
! 			 * @since 3.0.0
! 			 *
! 			 * @param int $id ID of the user marked as HAM.
! 			 */
  			do_action( 'make_ham_user', $id );
+ 		}
  	}
  
  	return $value;
***************
*** 411,416 ****
--- 494,508 ----
  		'sg' => 'Sango', 'sa' => 'Sanskrit', 'sr' => 'Serbian', 'hr' => 'Croatian', 'si' => 'Sinhala; Sinhalese', 'sk' => 'Slovak', 'sl' => 'Slovenian', 'se' => 'Northern Sami', 'sm' => 'Samoan', 'sn' => 'Shona', 'sd' => 'Sindhi', 'so' => 'Somali', 'st' => 'Sotho, Southern', 'es' => 'Spanish; Castilian', 'sc' => 'Sardinian', 'ss' => 'Swati', 'su' => 'Sundanese', 'sw' => 'Swahili',
  		'sv' => 'Swedish', 'ty' => 'Tahitian', 'ta' => 'Tamil', 'tt' => 'Tatar', 'te' => 'Telugu', 'tg' => 'Tajik', 'tl' => 'Tagalog', 'th' => 'Thai', 'bo' => 'Tibetan', 'ti' => 'Tigrinya', 'to' => 'Tonga (Tonga Islands)', 'tn' => 'Tswana', 'ts' => 'Tsonga', 'tk' => 'Turkmen', 'tr' => 'Turkish', 'tw' => 'Twi', 'ug' => 'Uighur; Uyghur', 'uk' => 'Ukrainian', 'ur' => 'Urdu', 'uz' => 'Uzbek',
  		've' => 'Venda', 'vi' => 'Vietnamese', 'vo' => 'Volapük', 'cy' => 'Welsh','wa' => 'Walloon','wo' => 'Wolof', 'xh' => 'Xhosa', 'yi' => 'Yiddish', 'yo' => 'Yoruba', 'za' => 'Zhuang; Chuang', 'zu' => 'Zulu' );
+ 
+ 	/**
+ 	 * Filter the language codes.
+ 	 *
+ 	 * @since MU
+ 	 *
+ 	 * @param array  $lang_codes Key/value pair of language codes where key is the short version.
+ 	 * @param string $code       A two-letter designation of the language.
+ 	 */
  	$lang_codes = apply_filters( 'lang_codes', $lang_codes, $code );
  	return strtr( $code, $lang_codes );
  }
***************
*** 498,528 ****
  
  	// Order by name
  	uksort( $output, 'strnatcasecmp' );
! 
  	$output = apply_filters( 'mu_dropdown_languages', $output, $lang_files, $current );
  	echo implode( "\n\t", $output );
  }
  
- /* Warn the admin if SECRET SALT information is missing from wp-config.php */
- function secret_salt_warning() {
- 	if ( !is_super_admin() )
- 		return;
- 	$secret_keys = array( 'AUTH_KEY', 'SECURE_AUTH_KEY', 'LOGGED_IN_KEY', 'NONCE_KEY', 'AUTH_SALT', 'SECURE_AUTH_SALT', 'LOGGED_IN_SALT', 'NONCE_SALT' );
- 	$out = '';
- 	foreach( $secret_keys as $key ) {
- 		if ( ! defined( $key ) )
- 			$out .= "define( '$key', '" . esc_html( wp_generate_password( 64, true, true ) ) . "' );<br />";
- 	}
- 	if ( $out != '' ) {
- 		$msg  = __( 'Warning! WordPress encrypts user cookies, but you must add the following lines to <strong>wp-config.php</strong> for it to be more secure.' );
- 		$msg .= '<br/>' . __( "Before the line <code>/* That's all, stop editing! Happy blogging. */</code> please add this code:" );
- 		$msg .= "<br/><br/><code>$out</code>";
- 
- 		echo "<div class='update-nag'>$msg</div>";
- 	}
- }
- add_action( 'network_admin_notices', 'secret_salt_warning' );
- 
  function site_admin_notice() {
  	global $wp_db_version;
  	if ( !is_super_admin() )
--- 590,608 ----
  
  	// Order by name
  	uksort( $output, 'strnatcasecmp' );
! 	/**
! 	 * Filter the languages available in the dropdown.
! 	 *
! 	 * @since MU
! 	 *
! 	 * @param array $output     HTML output of the dropdown.
! 	 * @param array $lang_files Available language files.
! 	 * @param string $current   The current language code.
! 	 */
  	$output = apply_filters( 'mu_dropdown_languages', $output, $lang_files, $current );
  	echo implode( "\n\t", $output );
  }
  
  function site_admin_notice() {
  	global $wp_db_version;
  	if ( !is_super_admin() )
***************
*** 595,601 ****
  	<?php if ( in_array( get_site_option( 'registration' ), array( 'all', 'blog' ) ) ) : ?>
  		<tr>
  			<th scope="row" colspan="2" class="th-full">
! 				<a href="<?php echo apply_filters( 'wp_signup_location', network_site_url( 'wp-signup.php' ) ); ?>"><?php _e( 'Create a New Site' ); ?></a>
  			</th>
  		</tr>
  	<?php endif; ?>
--- 675,685 ----
  	<?php if ( in_array( get_site_option( 'registration' ), array( 'all', 'blog' ) ) ) : ?>
  		<tr>
  			<th scope="row" colspan="2" class="th-full">
! 				<?php
! 				$signup_url = network_site_url( 'wp-signup.php' );
! 				/** This filter is documented in wp-login.php */
! 				?>
! 				<a href="<?php echo apply_filters( 'wp_signup_location', $signup_url ); ?>"><?php _e( 'Create a New Site' ); ?></a>
  			</th>
  		</tr>
  	<?php endif; ?>
***************
*** 604,621 ****
  }
  
  /**
!  * Grants super admin privileges.
   *
   * @since 3.0.0
!  * @param int $user_id
   */
  function grant_super_admin( $user_id ) {
  	global $super_admins;
  
  	// If global super_admins override is defined, there is nothing to do here.
! 	if ( isset($super_admins) )
  		return false;
  
  	do_action( 'grant_super_admin', $user_id );
  
  	// Directly fetch site_admins instead of using get_super_admins()
--- 688,712 ----
  }
  
  /**
!  * Grants Super Admin privileges.
   *
   * @since 3.0.0
!  * @param int $user_id ID of the user to be granted Super Admin privileges.
   */
  function grant_super_admin( $user_id ) {
  	global $super_admins;
  
  	// If global super_admins override is defined, there is nothing to do here.
! 	if ( isset( $super_admins ) )
  		return false;
  
+ 	/**
+ 	 * Fires before the user is granted Super Admin privileges.
+ 	 *
+ 	 * @since 3.0.0
+ 	 *
+ 	 * @param int $user_id ID of the user that is about to be granted Super Admin privileges.
+ 	 */
  	do_action( 'grant_super_admin', $user_id );
  
  	// Directly fetch site_admins instead of using get_super_admins()
***************
*** 625,630 ****
--- 716,729 ----
  	if ( $user && ! in_array( $user->user_login, $super_admins ) ) {
  		$super_admins[] = $user->user_login;
  		update_site_option( 'site_admins' , $super_admins );
+ 
+ 		/**
+ 		 * Fires after the user is granted Super Admin privileges.
+ 		 *
+ 		 * @since 3.0.0
+ 		 *
+ 		 * @param int $user_id ID of the user that was granted Super Admin privileges.
+ 		 */
  		do_action( 'granted_super_admin', $user_id );
  		return true;
  	}
***************
*** 632,649 ****
  }
  
  /**
!  * Revokes super admin privileges.
   *
   * @since 3.0.0
!  * @param int $user_id
   */
  function revoke_super_admin( $user_id ) {
  	global $super_admins;
  
  	// If global super_admins override is defined, there is nothing to do here.
! 	if ( isset($super_admins) )
  		return false;
  
  	do_action( 'revoke_super_admin', $user_id );
  
  	// Directly fetch site_admins instead of using get_super_admins()
--- 731,755 ----
  }
  
  /**
!  * Revokes Super Admin privileges.
   *
   * @since 3.0.0
!  * @param int $user_id ID of the user Super Admin privileges to be revoked from.
   */
  function revoke_super_admin( $user_id ) {
  	global $super_admins;
  
  	// If global super_admins override is defined, there is nothing to do here.
! 	if ( isset( $super_admins ) )
  		return false;
  
+ 	/**
+ 	 * Fires before the user's Super Admin privileges are revoked.
+ 	 *
+ 	 * @since 3.0.0
+ 	 *
+ 	 * @param int $user_id ID of the user Super Admin privileges are being revoked from.
+ 	 */
  	do_action( 'revoke_super_admin', $user_id );
  
  	// Directly fetch site_admins instead of using get_super_admins()
***************
*** 654,659 ****
--- 760,773 ----
  		if ( false !== ( $key = array_search( $user->user_login, $super_admins ) ) ) {
  			unset( $super_admins[$key] );
  			update_site_option( 'site_admins', $super_admins );
+ 
+ 			/**
+ 			 * Fires after the user's Super Admin privileges are revoked.
+ 			 *
+ 			 * @since 3.0.0
+ 			 *
+ 			 * @param int $user_id ID of the user Super Admin privileges were revoked from.
+ 			 */
  			do_action( 'revoked_super_admin', $user_id );
  			return true;
  		}
***************
*** 667,682 ****
   * By default editing of network is restricted to the Network Admin for that site_id this allows for this to be overridden
   *
   * @since 3.1.0
!  * @param integer $site_id The network/site id to check.
   */
  function can_edit_network( $site_id ) {
  	global $wpdb;
  
! 	if ($site_id == $wpdb->siteid )
  		$result = true;
  	else
  		$result = false;
  
  	return apply_filters( 'can_edit_network', $result, $site_id );
  }
  
--- 781,804 ----
   * By default editing of network is restricted to the Network Admin for that site_id this allows for this to be overridden
   *
   * @since 3.1.0
!  * @param integer $site_id The network/site ID to check.
   */
  function can_edit_network( $site_id ) {
  	global $wpdb;
  
! 	if ( $site_id == $wpdb->siteid )
  		$result = true;
  	else
  		$result = false;
  
+ 	/**
+ 	 * Filter whether this network can be edited from this page.
+ 	 *
+ 	 * @since 3.1.0
+ 	 *
+ 	 * @param bool $result  Whether the network can be edited from this page.
+ 	 * @param int  $site_id The network/site ID to check.
+ 	 */
  	return apply_filters( 'can_edit_network', $result, $site_id );
  }
  
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/nav-menu.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/nav-menu.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/nav-menu.php	2013-07-27 01:50:59.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/nav-menu.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 9,44 ****
   */
  class Walker_Nav_Menu_Edit extends Walker_Nav_Menu {
  	/**
  	 * @see Walker_Nav_Menu::start_lvl()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference.
  	 */
  	function start_lvl( &$output, $depth = 0, $args = array() ) {}
  
  	/**
  	 * @see Walker_Nav_Menu::end_lvl()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference.
  	 */
  	function end_lvl( &$output, $depth = 0, $args = array() ) {}
  
  	/**
! 	 * @see Walker::start_el()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item Menu item data object.
! 	 * @param int $depth Depth of menu item. Used for padding.
! 	 * @param object $args
  	 */
  	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		global $_wp_nav_menu_max_depth;
  		$_wp_nav_menu_max_depth = $depth > $_wp_nav_menu_max_depth ? $depth : $_wp_nav_menu_max_depth;
  
- 		$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
- 
  		ob_start();
  		$item_id = esc_attr( $item->ID );
  		$removed_args = array(
--- 9,55 ----
   */
  class Walker_Nav_Menu_Edit extends Walker_Nav_Menu {
  	/**
+ 	 * Starts the list before the elements are added.
+ 	 *
  	 * @see Walker_Nav_Menu::start_lvl()
+ 	 *
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference.
+ 	 * @param int    $depth  Depth of menu item. Used for padding.
+ 	 * @param array  $args   Not used.
  	 */
  	function start_lvl( &$output, $depth = 0, $args = array() ) {}
  
  	/**
+ 	 * Ends the list of after the elements are added.
+ 	 *
  	 * @see Walker_Nav_Menu::end_lvl()
+ 	 *
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference.
+ 	 * @param int    $depth  Depth of menu item. Used for padding.
+ 	 * @param array  $args   Not used.
  	 */
  	function end_lvl( &$output, $depth = 0, $args = array() ) {}
  
  	/**
! 	 * Start the element output.
! 	 *
! 	 * @see Walker_Nav_Menu::start_el()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item   Menu item data object.
! 	 * @param int    $depth  Depth of menu item. Used for padding.
! 	 * @param array  $args   Not used.
! 	 * @param int    $id     Not used.
  	 */
  	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		global $_wp_nav_menu_max_depth;
  		$_wp_nav_menu_max_depth = $depth > $_wp_nav_menu_max_depth ? $depth : $_wp_nav_menu_max_depth;
  
  		ob_start();
  		$item_id = esc_attr( $item->ID );
  		$removed_args = array(
***************
*** 57,63 ****
  				$original_title = false;
  		} elseif ( 'post_type' == $item->type ) {
  			$original_object = get_post( $item->object_id );
! 			$original_title = $original_object->post_title;
  		}
  
  		$classes = array(
--- 68,74 ----
  				$original_title = false;
  		} elseif ( 'post_type' == $item->type ) {
  			$original_object = get_post( $item->object_id );
! 			$original_title = get_the_title( $original_object->ID );
  		}
  
  		$classes = array(
***************
*** 214,220 ****
  		<?php
  		$output .= ob_get_clean();
  	}
! }
  
  /**
   * Create HTML list of nav menu input items.
--- 225,232 ----
  		<?php
  		$output .= ob_get_clean();
  	}
! 
! } // Walker_Nav_Menu_Edit
  
  /**
   * Create HTML list of nav menu input items.
***************
*** 230,253 ****
  		}
  	}
  
  	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent<ul class='children'>\n";
  	}
  
  	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent</ul>";
  	}
  
  	/**
! 	 * @see Walker::start_el()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item Menu item data object.
! 	 * @param int $depth Depth of menu item. Used for padding.
! 	 * @param object $args
  	 */
  	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		global $_nav_menu_placeholder;
--- 242,291 ----
  		}
  	}
  
+ 	/**
+ 	 * Starts the list before the elements are added.
+ 	 *
+ 	 * @see Walker_Nav_Menu::start_lvl()
+ 	 *
+ 	 * @since 3.0.0
+ 	 *
+ 	 * @param string $output Passed by reference. Used to append additional content.
+ 	 * @param int    $depth  Depth of page. Used for padding.
+ 	 * @param array  $args   Not used.
+ 	 */
  	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent<ul class='children'>\n";
  	}
  
+ 	/**
+ 	 * Ends the list of after the elements are added.
+ 	 *
+ 	 * @see Walker_Nav_Menu::end_lvl()
+ 	 *
+ 	 * @since 3.0.0
+ 	 *
+ 	 * @param string $output Passed by reference. Used to append additional content.
+ 	 * @param int    $depth  Depth of page. Used for padding.
+ 	 * @param array  $args   Not used.
+ 	 */
  	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent</ul>";
  	}
  
  	/**
! 	 * Start the element output.
! 	 *
! 	 * @see Walker_Nav_Menu::start_el()
! 	 *
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item   Menu item data object.
! 	 * @param int    $depth  Depth of menu item. Used for padding.
! 	 * @param array  $args   Not used.
! 	 * @param int    $id     Not used.
  	 */
  	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		global $_nav_menu_placeholder;
***************
*** 261,275 ****
  		$output .= $indent . '<li>';
  		$output .= '<label class="menu-item-title">';
  		$output .= '<input type="checkbox" class="menu-item-checkbox';
! 		if ( property_exists( $item, 'front_or_home' ) && $item->front_or_home ) {
! 			$title = sprintf( _x( 'Home: %s', 'nav menu front page title' ), $item->post_title );
  			$output .= ' add-to-top';
! 		} elseif ( property_exists( $item, 'label' ) ) {
  			$title = $item->label;
  		}
! 		$output .= '" name="menu-item[' . $possible_object_id . '][menu-item-object-id]" value="'. esc_attr( $item->object_id ) .'" /> ';
  		$output .= isset( $title ) ? esc_html( $title ) : esc_html( $item->title );
! 		$output .= '</label>';
  
  		// Menu item hidden fields
  		$output .= '<input type="hidden" class="menu-item-db-id" name="menu-item[' . $possible_object_id . '][menu-item-db-id]" value="' . $possible_db_id . '" />';
--- 299,321 ----
  		$output .= $indent . '<li>';
  		$output .= '<label class="menu-item-title">';
  		$output .= '<input type="checkbox" class="menu-item-checkbox';
! 
! 		if ( ! empty( $item->front_or_home ) )
  			$output .= ' add-to-top';
! 
! 		$output .= '" name="menu-item[' . $possible_object_id . '][menu-item-object-id]" value="'. esc_attr( $item->object_id ) .'" /> ';
! 
! 		if ( ! empty( $item->label ) ) {
  			$title = $item->label;
+ 		} elseif ( isset( $item->post_type ) ) {
+ 			/** This filter is documented in wp-includes/post-template.php */
+ 			$title = apply_filters( 'the_title', $item->post_title, $item->ID );
+ 			if ( ! empty( $item->front_or_home ) && _x( 'Home', 'nav menu home label' ) !== $title )
+ 				$title = sprintf( _x( 'Home: %s', 'nav menu front page title' ), $title );
  		}
! 
  		$output .= isset( $title ) ? esc_html( $title ) : esc_html( $item->title );
!  		$output .= '</label>';
  
  		// Menu item hidden fields
  		$output .= '<input type="hidden" class="menu-item-db-id" name="menu-item[' . $possible_object_id . '][menu-item-db-id]" value="' . $possible_db_id . '" />';
***************
*** 283,289 ****
  		$output .= '<input type="hidden" class="menu-item-classes" name="menu-item[' . $possible_object_id . '][menu-item-classes]" value="'. esc_attr( implode( ' ', $item->classes ) ) .'" />';
  		$output .= '<input type="hidden" class="menu-item-xfn" name="menu-item[' . $possible_object_id . '][menu-item-xfn]" value="'. esc_attr( $item->xfn ) .'" />';
  	}
! }
  
  /**
   * Prints the appropriate response to a menu quick search.
--- 329,336 ----
  		$output .= '<input type="hidden" class="menu-item-classes" name="menu-item[' . $possible_object_id . '][menu-item-classes]" value="'. esc_attr( implode( ' ', $item->classes ) ) .'" />';
  		$output .= '<input type="hidden" class="menu-item-xfn" name="menu-item[' . $possible_object_id . '][menu-item-xfn]" value="'. esc_attr( $item->xfn ) .'" />';
  	}
! 
! } // Walker_Nav_Menu_Checklist
  
  /**
   * Prints the appropriate response to a menu quick search.
***************
*** 487,537 ****
  }
  
  /**
-  * Displays a metabox for the nav menu theme locations.
-  *
-  * @since 3.0.0
-  */
- function wp_nav_menu_locations_meta_box() {
- 	global $nav_menu_selected_id;
- 
- 	if ( ! current_theme_supports( 'menus' ) ) {
- 		// We must only support widgets. Leave a message and bail.
- 		echo '<p class="howto">' . __('The current theme does not natively support menus, but you can use the &#8220;Custom Menu&#8221; widget to add any menus you create here to the theme&#8217;s sidebar.') . '</p>';
- 		return;
- 	}
- 
- 	$locations = get_registered_nav_menus();
- 	$menus = wp_get_nav_menus();
- 	$menu_locations = get_nav_menu_locations();
- 	$num_locations = count( array_keys($locations) );
- 
- 	echo '<p class="howto">' . _n( 'Select a menu to use within your theme.', 'Select the menus you will use in your theme.', $num_locations ) . '</p>';
- 
- 	foreach ( $locations as $location => $description ) {
- 		?>
- 		<p>
- 			<label class="howto" for="locations-<?php echo $location; ?>">
- 				<span><?php echo $description; ?></span>
- 				<select name="menu-locations[<?php echo $location; ?>]" id="locations-<?php echo $location; ?>">
- 					<option value="0"></option>
- 					<?php foreach ( $menus as $menu ) : ?>
- 					<option<?php selected( isset( $menu_locations[ $location ] ) && $menu_locations[ $location ] == $menu->term_id ); ?>
- 						value="<?php echo $menu->term_id; ?>"><?php echo wp_html_excerpt( $menu->name, 40, '&hellip;' ); ?></option>
- 					<?php endforeach; ?>
- 				</select>
- 			</label>
- 		</p>
- 	<?php
- 	}
- 	?>
- 	<p class="button-controls">
- 		<?php submit_button( __( 'Save' ), 'primary right', 'nav-menu-locations', false, wp_nav_menu_disabled_check( $nav_menu_selected_id ) ); ?>
- 		<span class="spinner"></span>
- 	</p>
- 	<?php
- }
- 
- /**
   * Check whether to disable the Menu Locations meta box submit button
   *
   * @since 3.6.0
--- 534,539 ----
